#include <iostream>
#include <fstream>
using namespace std;

const int MAXS = 100;
const int MAXA = 200;

enum Categ {ALIMENTARI, CASALINGHI, GIOCATTOLI};

struct Articolo {
	int codice;
	char descr[MAXS];
	Categ categoria;
	float prezzo;
};
struct Listino {
	Articolo art[MAXA];
	int numArt;
};

bool trovaArticolo(const Listino* pl, int cod, Articolo* pa){
	for(int i=0; i<pl->numArt; i++)
		if(pl->art[i].codice == cod) {
			*pa = pl->art[i];
			return true;
		}
	return false;
}

void scontrino(const Listino* pl, const int c[], const int q[], int n) {
	float tot = 0.0f;
	float subtot;
	for(int i=0; i<n; i++) {
		Articolo a;
		bool trovato = trovaArticolo(pl, c[i], &a);
		if(trovato) {
			cout << a.codice << " " << a.descr;
			cout << " x " << q[i] << endl;
			subtot = a.prezzo * q[i];
			cout << "Subtotale: " << subtot << endl;
			tot += subtot;
		} else {
			cout << c[i] << ": non trovato" << endl;
		}
	}
	cout << "--------------" << endl;
	cout << "Totale: " << tot << endl;
}

int caricaListino(Listino* pl, const char nomef[]){
	fstream f;
	f.open(nomef, ios::in);
	Articolo a;
	int q = 0;
	char c;
	while(f >> a.codice >> c >> a.descr >> a.prezzo) {
		switch(c) {
			case 'A': a.categoria = ALIMENTARI;
				break;
			case 'C': a.categoria = CASALINGHI;
				break;
			case 'G': a.categoria = GIOCATTOLI;
				break; 
		}
		pl->art[pl->numArt] = a;
		pl->numArt++;
		q++;
	}
	return q;
}

bool prezzoMax(const Listino* pl, const int c[], int n, Articolo* pa) {
	Articolo a;
	Articolo m;
	m.prezzo = -1;
	for(int i=0; i<n; i++) {
		bool trovato = trovaArticolo(pl, c[i], &a);
		if(trovato && a.prezzo > m.prezzo) 
			m = a;
	}
	if(m.prezzo != -1) {
		*pa = m;
		return true;
	}
	return false;
}

void stampaPrezziMedi(const Listino* pl){
	int q[3] = {0};
	float p[3] = {0};
	for(int i=0; i<pl->numArt; i++) {
		q[pl->art[i].categoria]++;
		p[pl->art[i].categoria] += pl->art[i].prezzo;
	}
	cout << "Prezzi medi delle categorie Alimentari, Casalinghi, Giocattoli: " << endl;
	for(int i=0; i<3; i++)
		if(q[i] > 0) 
			cout << p[i]/q[i] << endl;
		else
			cout << "non presenti" << endl;
}

bool isSelected(Articolo a, char operatore, int cod) {
	switch(operatore) {
		case '>': return a.codice > cod;
		case '=': return a.codice == cod;
		case '<': return a.codice < cod;
	}
	return false;
}

int seleziona(const Listino* pl, char operatore, int cod, Articolo v[]) {
	int quanti = 0;
	for(int i=0; i<pl->numArt; i++) {
		if(isSelected(pl->art[i], operatore, cod))
			v[quanti++] = pl->art[i];	
	}
	return quanti;
}
